package de.web.minecraftandi;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerChatEvent;

/**
 * Functions for commands handled from xCommandListener
 * @author Andi
 */
public class xCommands {
	public static void xCommandHelp(PlayerChatEvent event) {
		Player player = event.getPlayer();
		player.sendMessage(ChatColor.YELLOW + "[xLevel Help]");
		player.sendMessage(ChatColor.LIGHT_PURPLE + " /xl help" + ChatColor.GRAY + " - displays this player help menu");
		player.sendMessage(ChatColor.LIGHT_PURPLE + " /xl status" + ChatColor.GRAY + " - displays your status information");
		player.sendMessage(ChatColor.LIGHT_PURPLE + " /xl classes" + ChatColor.GRAY + " - displays all avaiable classes");
		player.sendMessage(ChatColor.LIGHT_PURPLE + " /xl see [class]" + ChatColor.GRAY + " - see information about [class]");
		player.sendMessage(ChatColor.LIGHT_PURPLE + " /xl class [class]" + ChatColor.GRAY + " - set your class");
		player.sendMessage(ChatColor.LIGHT_PURPLE + " /xl reset" + ChatColor.GRAY + " - reset your character (class, level, exp)");
		player.sendMessage(ChatColor.DARK_RED + " /xl admin" + ChatColor.GRAY + " - displays admin help menu");
	}
	
	public static void xCommandAdmin(PlayerChatEvent event) {
		Player player = event.getPlayer();
		player.sendMessage(ChatColor.YELLOW + "[xLevel]");
		player.sendMessage(ChatColor.DARK_RED + " /xl setclass [player] [class]" + ChatColor.GRAY + " - set player class");
		player.sendMessage(ChatColor.DARK_RED + " /xl setlevel [player] [level]" + ChatColor.GRAY + " - set player level");
		player.sendMessage(ChatColor.DARK_RED + " /xl setexp [player] [exp]" + ChatColor.GRAY + " - set player exp");
		player.sendMessage(ChatColor.DARK_RED + " /xl get [player]" + ChatColor.GRAY + " - displays status information of [player]");
		player.sendMessage(ChatColor.DARK_RED + " /xl new [player]" + ChatColor.GRAY + " - create new database entry for [player]");
		player.sendMessage(ChatColor.DARK_RED + " /xl resetall [player]" + ChatColor.GRAY + " - reset status information of [player]");
		player.sendMessage(ChatColor.DARK_RED + " /xl save" + ChatColor.GRAY + " - save all data");
		player.sendMessage(ChatColor.DARK_RED + " /xl reload" + ChatColor.GRAY + " - reloads the xLevel config");
	}
	
	public static void xCommandStatus(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel]");
		if(xDataManager.getData(player.getName()).equalsIgnoreCase("none")) {
			player.sendMessage(ChatColor.GRAY + " You are not in the database! Please report an Admin!!");
		} else {
			String playerData = xDataManager.getData(player.getName());
			String[] split = playerData.split(" ");
			player.sendMessage(ChatColor.GRAY + " Player: " + player.getName());
			player.sendMessage(ChatColor.GRAY + " Class: " + split[0]);
			player.sendMessage(ChatColor.GRAY + " Level: " + split[1]);
			player.sendMessage(ChatColor.GRAY + " Exp: " + split[2] + "/" + (300*(Integer.parseInt(split[1])+1)));
		}
	}
	
	public static void xCommandClasses(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel]");
		player.sendMessage(ChatColor.GRAY + " The classes are: ");
		player.sendMessage(ChatColor.GOLD + " Archer");
		player.sendMessage(ChatColor.GOLD + " Warrior");
		player.sendMessage(ChatColor.GOLD + " Magician");
		player.sendMessage(ChatColor.GOLD + " Priest");
		player.sendMessage(ChatColor.GRAY + " Get detailed information with " + ChatColor.LIGHT_PURPLE + "/xl see [classname]");
		player.sendMessage(ChatColor.GRAY + " When you reach level 1 you can choose your class");
		player.sendMessage(ChatColor.GRAY + " using " + ChatColor.LIGHT_PURPLE + "/xl class [classname]");
	}
	
	public static void xCommandSeeArcher(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel - Archer]");
		player.sendMessage(ChatColor.GRAY + " Select skill: arrow (rightlick)");
		player.sendMessage(ChatColor.GRAY + " Use skill: bow (leftlick)");
		player.sendMessage(ChatColor.GRAY + " Skills: " + ChatColor.GOLD + "fire arrow (1), invisible (2, use feather!),");
		player.sendMessage(ChatColor.GOLD + " critical arrow (3), hook (4), poisoned arrow (5)");
		player.sendMessage(ChatColor.GRAY + " All skill cooldowns are shorten form level 6 to 10.");
		player.sendMessage(ChatColor.GRAY + " All skills are getting better from level 11 to 20.");
	}
	
	public static void xCommandSeeWarrior(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel - Warrior]");
		player.sendMessage(ChatColor.GRAY + " Select skill: bone (rightlick)");
		player.sendMessage(ChatColor.GRAY + " Activate skill: sword (rightlick)");
		player.sendMessage(ChatColor.GRAY + " Use skill: sword (leftlick)");
		player.sendMessage(ChatColor.GRAY + " Skills: " + ChatColor.GOLD + "pushing (1), sprint (2), crippling (3),");
		player.sendMessage(ChatColor.GOLD + " block (4), skullsplitter (5)");
		player.sendMessage(ChatColor.GRAY + " All skill cooldowns are shorten form level 6 to 10.");
		player.sendMessage(ChatColor.GRAY + " All skills are getting better from level 11 to 20.");
	}
	
	public static void xCommandSeeMagician(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel - Magician]");
		player.sendMessage(ChatColor.GRAY + " Select skill: book (rightlick)");
		player.sendMessage(ChatColor.GRAY + " Use skill: stick (leftlick)");
		player.sendMessage(ChatColor.GRAY + " Skills: " + ChatColor.GOLD + "energy wave (1), teleport (2), icy wind (3),");
		player.sendMessage(ChatColor.GOLD + " leaves jail (4), lightning strike (5)");
		player.sendMessage(ChatColor.GRAY + " All skill cooldowns are shorten form level 6 to 10.");
		player.sendMessage(ChatColor.GRAY + " All skills are getting better from level 11 to 20.");
	}
	
	public static void xCommandSeePriest(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel - Magician]");
		player.sendMessage(ChatColor.GRAY + " Select skill: book (rightlick)");
		player.sendMessage(ChatColor.GRAY + " Use skill: axe (rightlick)");
		player.sendMessage(ChatColor.GRAY + " Skills: " + ChatColor.GOLD + "heal (1), summon wolves (2), defense buff (3),");
		player.sendMessage(ChatColor.GOLD + " strength buff (4), speed buff (5)");
		player.sendMessage(ChatColor.GRAY + " All skill cooldowns are shorten form level 6 to 10.");
		player.sendMessage(ChatColor.GRAY + " All skills are getting better from level 11 to 20.");
	}
	
	public static void xCommandClass(PlayerChatEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 3) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
			String playerclass = null;
			try {
				String playerData = xDataManager.getData(playername);
				if(playerData.equalsIgnoreCase("none")) {
					player.sendMessage(ChatColor.GRAY + " You are not in the database! Please report an Admin!!");
				} else {
					playerclass = split[2];
					if(playerclass.equals("Archer") || playerclass.equals("Warrior") || playerclass.equals("Magician") || playerclass.equals("Priest"))
					{
						String[] split2 = playerData.split(" ");
						if (split2[0].equalsIgnoreCase("Commoner")) {
							if(Integer.parseInt(split2[1]) != 0) {
								playerData = playerclass + " " + split2[1] + " " + split2[2];
								xDataManager.setData(playername, playerData);
								player.sendMessage(ChatColor.GRAY + " You chose " + playerclass + " as your class!");
							} else {
								player.sendMessage(ChatColor.GRAY + " You have not yet reached level 1!");
								player.sendMessage(ChatColor.GRAY + " See you level and exp using " + ChatColor.LIGHT_PURPLE + "/xl status" + ChatColor.GRAY + "!");
							}
						} else {
							player.sendMessage(ChatColor.GRAY + " You have already set your class!");
							player.sendMessage(ChatColor.GRAY + " If you want an other class, use " + ChatColor.LIGHT_PURPLE + "/xl reset" + ChatColor.GRAY + "!");
						}
					} else {
						player.sendMessage(ChatColor.GRAY + " " + playerclass + " was not registered!");
						player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl classes" + ChatColor.GRAY + " to see all classes!");
					}
				}
			} catch (Exception E){
				player.sendMessage(ChatColor.GRAY + " " + playerclass + " was not registered!");
				player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl classes" + ChatColor.GRAY + " to see all classes!");
			}
		}
	}
	
	public static void xCommandReset(PlayerChatEvent event) {
		Player player = event.getPlayer();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 2) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
			player.sendMessage(ChatColor.GRAY + " This will delete your character and you will have to");
			player.sendMessage(ChatColor.GRAY + " restart leveling! If you are really sure to reset, use");
			player.sendMessage(ChatColor.GRAY + " " + ChatColor.LIGHT_PURPLE + "/xl reset yes" + ChatColor.GRAY + ", if not do nothing!");
		}
	}
	
	public static void xCommandResetYes(PlayerChatEvent event) {
		Player player = event.getPlayer();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 3) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
			if(!xDataManager.getData(player.getName()).equalsIgnoreCase("none")) {
				xDataManager.resetAll(player.getName());
				player.sendMessage(ChatColor.GRAY + " Your database entry has been reset!");
			} else {
				player.sendMessage(ChatColor.GRAY + " You are not in the database! Please report an admin!");
			}
		}
	}
	
	public static void xCommandSetClass(PlayerChatEvent event) {
		Player player = event.getPlayer();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 4) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
			String playerclass = null;
			try {
				String playerData = xDataManager.getData(split[2]);
				if(playerData.equalsIgnoreCase("none")) {
					player.sendMessage(ChatColor.GRAY + " " + split[2] + " is not in the database!");
					player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl new [player]" + ChatColor.GRAY + " to create a new entry!");
				} else {
					playerclass = split[3];
					if(playerclass.equals("Commoner") || playerclass.equals("Archer") || playerclass.equals("Warrior") || playerclass.equals("Magician") || playerclass.equals("Priest"))
					{
						String[] split2 = playerData.split(" ");
						if(Integer.parseInt(split2[1]) != 0) {
							playerData = playerclass + " " + split2[1] + " " + split2[2];
							xDataManager.setData(split[2], playerData);
							player.sendMessage(ChatColor.GRAY + " Class of " + split[2] + " set to " + playerclass + "!");
						} else {
							player.sendMessage(ChatColor.GRAY + " " + split[2] + " has not yet reached level 1!");
							player.sendMessage(ChatColor.GRAY + " First set " + split[2] + "'s level at least to 1 using ");
							player.sendMessage(ChatColor.GRAY + " " + ChatColor.LIGHT_PURPLE + "/xl setlevel [player] [level]" + ChatColor.GRAY + "!");
						}
					} else {
						player.sendMessage(ChatColor.GRAY + " " + playerclass + " was not registered!");
						player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl classes" + ChatColor.GRAY + " to see all classes!");
					}
				}
			} catch (Exception E){
				player.sendMessage(ChatColor.GRAY + " " + playerclass + " was not registered!");
				player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl classes" + ChatColor.GRAY + " to see all classes!");
			}
		}
	}
	
	public static void xCommandSetLevel(PlayerChatEvent event) {
		Player player = event.getPlayer();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 4) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
			int level = 0;
			try {
				String playerData = xDataManager.getData(split[2]);
				if(playerData.equalsIgnoreCase("none")) {
					player.sendMessage(ChatColor.GRAY + " " + split[2] + " is not in the database!");
					player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl new [player]" + ChatColor.GRAY + " to create a new entry!");
				} else {
					level = Integer.parseInt (split[3]);
					if((level >= 0) && (level <= 20)) {
						String[] split2 = playerData.split(" ");
						player.sendMessage(ChatColor.GRAY + " Level of " + split[2] + " set to " + split[3] + "!");
						playerData = split2[0] + " " + level + " " + split2[2];
						if (level == 0) {
							playerData = "Commoner " + level + " " + split2[2];
							player.sendMessage(ChatColor.GRAY + " Class of " + split[2] + " set to Commoner!");
						}
						xDataManager.setData(split[2], playerData);
					} else {
						player.sendMessage(ChatColor.GRAY + " [level] has to be an number between 0 and 20!");
					}
				}
			} catch (Exception E){
				player.sendMessage(ChatColor.GRAY + " [level] has to be an number between 0 and 20!");
			}
		}
	}
	
	public static void xCommandSetExp(PlayerChatEvent event) {
		Player player = event.getPlayer();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 4) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
			int exp = 0;
			try {
				String playerData = xDataManager.getData(split[2]);
				if(playerData.equalsIgnoreCase("none")) {
					player.sendMessage(ChatColor.GRAY + " " + split[2] + " is not in the database!");
					player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl new [player]" + ChatColor.GRAY + " to create a new entry!");
				} else {
					exp = Integer.parseInt (split[3]);
					String[] split2 = playerData.split(" ");
					if((exp >= 0) && (exp <= (300*(Integer.parseInt(split2[1])+1)))) {
						playerData = split2[0] + " " + split2[1] + " " + exp;
						xDataManager.setData(split[2], playerData);
						player.sendMessage(ChatColor.GRAY + " Exp of " + split[2] + " set to " + split[3] + "!");
					} else {
						player.sendMessage(ChatColor.GRAY + " [exp] has to be an number between 0 and" + (300*(Integer.parseInt(split2[1])+1)) +"!");
					}
				}
			} catch (Exception E){
				String playerData = xDataManager.getData(split[2]);
				String[] split2 = playerData.split(" ");
				player.sendMessage(ChatColor.GRAY + " [exp] has to be an number between 0 and" + (300*(Integer.parseInt(split2[1])+1)) +"!");
			}
		}
	}
	
	public static void xCommandGet(PlayerChatEvent event) {
		Player player = event.getPlayer();
		player.sendMessage(ChatColor.YELLOW + "[xLevel]");

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 3) {
			if(xDataManager.getData(split[2]).equalsIgnoreCase("none")) {
				player.sendMessage(ChatColor.GRAY + " " + split[2] + " is not in the database!");
				player.sendMessage(ChatColor.GRAY + " Use " + ChatColor.LIGHT_PURPLE + "/xl new [player]" + ChatColor.GRAY + " to create a new entry!");
			} else {
				String playerData = xDataManager.getData(split[2]);
				String[] split2 = playerData.split(" ");
				player.sendMessage(ChatColor.GRAY + " Player: " + split[2]);
				player.sendMessage(ChatColor.GRAY + " Class: " + split2[0]);
				player.sendMessage(ChatColor.GRAY + " Level: " + split2[1]);
				player.sendMessage(ChatColor.GRAY + " Exp: " + split2[2]  + "/" + (300*(Integer.parseInt(split2[1])+1)));
			}
		}
	}
	
	public static void xCommandNew(PlayerChatEvent event) {
		Player player = event.getPlayer();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 3) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
				if(xDataManager.getData(split[2]).equalsIgnoreCase("none")) {
					xDataManager.NewEntry(split[2]);
					player.sendMessage(ChatColor.GRAY + " Database entry for " + split[2] + " has been created!");
				} else {
					player.sendMessage(ChatColor.GRAY + split[2] + " is already in the database!");
				}
		}
	}
	
	public static void xCommandResetAll(PlayerChatEvent event) {
		Player player = event.getPlayer();

		String command = event.getMessage();
		String[] split = command.split(" ");
		
		if(split.length == 3) {
			player.sendMessage(ChatColor.YELLOW + "[xLevel]");
			if(!xDataManager.getData(split[2]).equalsIgnoreCase("none")) {
				xDataManager.resetAll(split[2]);
				player.sendMessage(ChatColor.GRAY + " Database entry for " + split[2] + " has been reset!");
			} else {
				player.sendMessage(ChatColor.GRAY + split[2] + " is not in the database!");
			}
		}
	}
	
	public static void xCommandSave(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel]");
		player.sendMessage(ChatColor.GRAY + " All playerdata saved!");
		if (xConfig.saveCooldowns) {
			player.sendMessage(ChatColor.GRAY + " All cooldowns saved!");
		}
		if (xConfig.saveLastUsedSkill) {
			player.sendMessage(ChatColor.GRAY + " All last used skills saved!");
		}
	}
	
	public static void xCommandReload(PlayerChatEvent event) {
		Player player = event.getPlayer();

		player.sendMessage(ChatColor.YELLOW + "[xLevel]");
		if (xConfig.reload()) {
			player.sendMessage(ChatColor.GRAY + " The config was successfully reloaded!");
		} else {
			player.sendMessage(ChatColor.GRAY + " The was an error while reloading the config!");
		}
	}
}
