package de.web.minecraftandi;

import java.io.File;

import org.bukkit.plugin.Plugin;

import com.nijikokun.bukkit.Permissions.Permissions;

public class xConfig {
	private static final String settingsFile = "xLevel.yml";
	private static File settingsFolder = null;
	public static boolean usePermissions;
	public static boolean opIsAdmin;
	public static boolean playersCanChooseClass;
	public static boolean playersCanReset;
	public static boolean playersCanSeeOthers;
	public static int saveInterval;
	public static boolean logSaving;
	public static boolean saveCooldowns;
	public static boolean saveLastUsedSkill;
	public static boolean needItems;
	public static boolean opNoCooldown;
	private static xLevel plugin;

	public static void startup(xLevel instance) {
	        plugin = instance;
	}
	
	public static void initialize(File dataFolder) {
        if(!dataFolder.exists()) {
            dataFolder.mkdirs();
        }
        settingsFolder = dataFolder;

        File configFile  = new File(dataFolder, settingsFile);
        BetterConfig config = new BetterConfig(configFile);
        
        config.load();
        
        usePermissions = config.getBoolean("usePermissions",true);
        opIsAdmin = config.getBoolean("opIsAdmin",false);
        playersCanChooseClass = config.getBoolean("playersCanChooseClass",true);
        playersCanReset = config.getBoolean("playersCanReset",true);
        playersCanSeeOthers = config.getBoolean("playersCanSeeOthers",false);
        saveInterval = config.getInt("saveInterval",300);
        logSaving = config.getBoolean("logSaving",false);
        saveCooldowns = config.getBoolean("saveCooldowns",false);
        saveLastUsedSkill = config.getBoolean("saveLastUsedSkill",true);
        needItems = config.getBoolean("needItems",true);
        opNoCooldown = config.getBoolean("opNoCooldown",false);
        
        config.save();
    }
	
	public static boolean reload() {
      
        File configFile  = new File(settingsFolder, settingsFile);
        BetterConfig config = new BetterConfig(configFile);
        
        config.load();
        
        usePermissions = config.getBoolean("usePermissions",true);
        if (usePermissions) {
        	xLevel.permissionHandler = null;
        	Plugin permissionsPlugin = plugin.getServer().getPluginManager().getPlugin("Permissions");
            if (permissionsPlugin != null) {
            	xLevel.permissionHandler = ((Permissions) permissionsPlugin).getHandler();
            } else {
            	usePermissions = false;
            }
        } else {
        	xLevel.permissionHandler = null;
        }
        opIsAdmin = config.getBoolean("opIsAdmin",false);
        playersCanChooseClass = config.getBoolean("playersCanChooseClass",true);
        playersCanReset = config.getBoolean("playersCanReset",true);
        playersCanSeeOthers = config.getBoolean("playersCanSeeOthers",false);
        logSaving = config.getBoolean("logSaving",false);
        saveCooldowns = config.getBoolean("saveCooldowns",false);
        saveLastUsedSkill = config.getBoolean("saveLastUsedSkill",true);
        needItems = config.getBoolean("needItems",true);
        opNoCooldown = config.getBoolean("opNoCooldown",false);
        
        config.save();
        
        return true;
    }
}
