package de.web.minecraftandi;

import java.util.ArrayList;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.craftbukkit.entity.CraftPlayer;
import org.bukkit.entity.CreatureType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Wolf;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;

public class xPriest {
	public static boolean skill1(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
	
		String playerData = xDataManager.getData(playername);
		String[] split = playerData.split(" ");
		int level = Integer.parseInt(split[1]);
		
		int distance = 15;
		if (level >= 11) {
			distance = 25;
		}
		
		int healAmount = 6;
		if (level >= 16) {
			healAmount = 10;
		}
		
		Block targetBlock = player.getTargetBlock(null, distance);
		Player[] playerList = player.getServer().getOnlinePlayers();
		
		boolean canUse = false;
		for (Player victim : playerList) {
			Location loc1 = targetBlock.getLocation();
			Location loc2 = victim.getLocation();
		 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
		 	if (distanceAway >= 3.0D)
				continue;
			int healthVictim = victim.getHealth();
			if ((victim.getHealth() + healAmount) <= 20) {
				victim.setHealth(healthVictim + healAmount);
			} else {
				victim.setHealth(20);
			}
			player.sendMessage(ChatColor.GRAY + "*** You healed " + victim.getName() + "!");
			victim.sendMessage(ChatColor.GRAY + "*** You have been healed by " + player.getName() + "!");
			canUse = true;
		}
		
		if (!canUse) {
			int healthPlayer = player.getHealth();
			if ((player.getHealth() + healAmount) <= 20) {
				player.setHealth(healthPlayer + healAmount);
			} else {
				player.setHealth(20);
			}
			player.sendMessage(ChatColor.GRAY + "*** You healed yourself!");
			canUse = true;
		}
		
		if (canUse) {
			int exp = Integer.parseInt(split[2]);
			exp = exp + 10;
			if (exp>=(300*(level+1))) {
				exp = 0;
				if(level<20) {
					level++;
				}
				player.sendMessage(ChatColor.YELLOW + "[xLevel]");
				player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
				if (split[0].equalsIgnoreCase("Commoner")) {
					player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
				}
				if (level == 20) {
					player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
				}
			}
			
			String[] split2 = playerData.split(" ");
			playerData = split2[0] + " " + level + " " + exp;
			xDataManager.setData(playername, playerData);
		}
		return canUse;
	}

	public static boolean skill2(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.PORK;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			if (xConfig.needItems) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				hasItem = true;
			}
		}
		
		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 15;
			if (level >= 11) {
				distance = 25;
			}
			
			int wolfHealth = 2;
			if (level >= 16) {
				wolfHealth = 4;
			}
			
			Block targetBlock = player.getTargetBlock(null, distance);
			Player[] playerList = player.getServer().getOnlinePlayers();
			
			boolean canUse = true;
			
			player.sendMessage(ChatColor.GRAY + "*** You have summoned wolves!");
			
			LivingEntity wolfA;
			Wolf wolfB;
			
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
			 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			 	if (distanceAway >= 3.0D)
					continue;
				victim.sendMessage(ChatColor.GRAY + "*** Wolves have been hunted to you!");
			}
			
			ArrayList<Wolf> wolfList = new ArrayList<Wolf>();
			
			for (int i = 1; i <= 2; i++) {
				wolfA = player.getWorld().spawnCreature(targetBlock.getRelative(BlockFace.UP).getLocation(), CreatureType.WOLF);
				wolfB = (Wolf)wolfA;
				wolfB.setOwner(player);
				wolfB.setHealth(wolfHealth);
				wolfList.add(wolfB);
				
				for (Player victim : playerList) {
					Location loc1 = targetBlock.getLocation();
					Location loc2 = victim.getLocation();
				 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
				 	if (distanceAway >= 3.0D)
						continue;
				 	wolfB.setTarget(victim);
				}
			}
			
			xEffectManager.setPriestEffectSummonWolves(player.getName(), wolfList);
			
			if (canUse) {
				int exp = Integer.parseInt(split[2]);
				exp = exp + 15;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
			return canUse;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}

	public static boolean skill3(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.WOOL;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			if (xConfig.needItems) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				hasItem = true;
			}
		}
		
		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 15;
			if (level >= 11) {
				distance = 25;
			}
			
			Block targetBlock = player.getTargetBlock(null, distance);
			Player[] playerList = player.getServer().getOnlinePlayers();
			
			Player buffed = player;
			
			boolean canUse = false;
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
			 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			 	if (distanceAway >= 3.0D)
					continue;
			 	buffed = victim;
				player.sendMessage(ChatColor.GRAY + "*** You buffed " + victim.getName() + " for defense!");
				victim.sendMessage(ChatColor.GRAY + "*** You have been buffed by " + player.getName() + " for defense!");
				canUse = true;
			}
			
			if (!canUse) {
				player.sendMessage(ChatColor.GRAY + "*** You buffed yourself for defense!");
				canUse = true;
			}

			xEffectManager.setPriestEffectDefBuff(player.getName(), buffed);
			
			if (canUse) {
				int exp = Integer.parseInt(split[2]);
				exp = exp + 10;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
			return canUse;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}

	public static boolean skill4(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.WOOL;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			if (xConfig.needItems) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				hasItem = true;
			}
		}
		
		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 15;
			if (level >= 11) {
				distance = 25;
			}
			
			Block targetBlock = player.getTargetBlock(null, distance);
			Player[] playerList = player.getServer().getOnlinePlayers();
			
			Player buffed = player;
			
			boolean canUse = false;
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
			 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			 	if (distanceAway >= 3.0D)
					continue;
			 	buffed = victim;
				player.sendMessage(ChatColor.GRAY + "*** You buffed " + victim.getName() + " for strength!");
				victim.sendMessage(ChatColor.GRAY + "*** You have been buffed by " + player.getName() + " for strength!");
				canUse = true;
			}
			
			if (!canUse) {
				player.sendMessage(ChatColor.GRAY + "*** You buffed yourself for strength!");
				canUse = true;
			}

			xEffectManager.setPriestEffectStrBuff(player.getName(), buffed);
			
			if (canUse) {
				int exp = Integer.parseInt(split[2]);
				exp = exp + 10;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
			return canUse;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}

	public static boolean skill5(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.WOOL;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			if (xConfig.needItems) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				hasItem = true;
			}
		}
		
		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 15;
			if (level >= 11) {
				distance = 25;
			}
			
			Block targetBlock = player.getTargetBlock(null, distance);
			Player[] playerList = player.getServer().getOnlinePlayers();
			
			Player buffed = player;
			
			boolean canUse = false;
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
			 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			 	if (distanceAway >= 3.0D)
					continue;
			 	buffed = victim;
				player.sendMessage(ChatColor.GRAY + "*** You buffed " + victim.getName() + " for speed!");
				victim.sendMessage(ChatColor.GRAY + "*** You have been buffed by " + player.getName() + " for speed! Crouch down!");
				canUse = true;
			}
			
			if (!canUse) {
				player.sendMessage(ChatColor.GRAY + "*** You buffed yourself for speed! Crouch down!");
				canUse = true;
			}

			xEffectManager.setPriestEffectSpeedBuff(player.getName(), buffed);
			
			if (canUse) {
				int exp = Integer.parseInt(split[2]);
				exp = exp + 10;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
			return canUse;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}
}
